// Sopa de letras

public class Matriz
{
  private int datos[][];

  // Constructores

  public Matriz (int filas, int columnas)
  {
    this.datos = new int [filas][columnas];
  }

  public Matriz (int datos[][])
  {
    this.datos = datos;
  }

  // Salida estndar

  public String toString ()
  {
    int    i,j;
    String resultado = "";

    for (i=0; i<datos.length; i++) {

		resultado += datos[i][0];

        for (j=1; j<datos[i].length; j++)
            resultado += " "+datos[i][j];

		resultado += "\n";
	}

    return resultado;
  }

  // Ejercicio 2: Bsqueda de una secuencia
  // --------------------------------------

  public int[] encuentra (int vector[])
  {
	  int i,j;
	  int pos[] = new int[2];

	  pos[0] = -1;
	  pos[1] = -1;

	  for (i=0; i<datos.length; i++) {
		  for (j=0; j<datos.length; j++) {
		      if (encuentraPos3(vector,i,j)) {
				  pos[0] = i;
				  pos[1] = j;
			  }
		  }
	  }

	  return pos;
  }

  private boolean encuentraPos (int vector[], int x, int y)
  {
	  int     dx,dy;
	  boolean encontrado = false;

	  for (dx=-1; dx<=1; dx++) {
		  for (dy=-1; dy<=1; dy++) {
			  if (encuentraDir(vector,x,y,dx,dy)) {
				  encontrado = true;
			  }
		  }
	  }

	  return encontrado;
  }


  private boolean encuentraDir (int vector[], int x, int y, int dx, int dy)
  {
	  int     k, px, py;
	  boolean ok = true;

	  px = x;
	  py = y;

	  for (k=0; k<vector.length; k++) {

		  if (  (px>=0) && (px<datos.length)
			 && (py>=0) && (py<datos[0].length)) {

			 if (datos[px][py]!=vector[k])
	  	        ok = false;
	      
		  } else {
			  ok = false;
		  }

		  px += dx;
		  py += dy;
      }

	  return ok;
  }  



  // Variantes y mejoras

  // 0. Implementacin alternativa de encuentraDir

  private boolean encuentraPos2 (int vector[], int x, int y)
  {
	  return encuentraDir(vector,x,y, 1, 0)
		  || encuentraDir(vector,x,y,-1, 0)
		  || encuentraDir(vector,x,y, 0, 1)
		  || encuentraDir(vector,x,y, 0,-1)
		  || encuentraDir(vector,x,y, 1, 1)
		  || encuentraDir(vector,x,y, 1,-1)
		  || encuentraDir(vector,x,y,-1, 1)
		  || encuentraDir(vector,x,y,-1,-1);
  }

  // 1. Eliminacin de algunas iteraciones innecesarias:
  //
  //		encuentra:     for ... && (pos[0]==-1) ...
  //		encuentraPos:  for ... && !encontrado ...
  //		encuentraDir:  for ... && ok

  // 2. Reduccin del nmero de comprobaciones

  private boolean encuentraDir2 (int vector[], int x, int y, int dx, int dy)
  {
	  int     k, px, py;
	  int     finx, finy;
	  boolean ok = true;

	  finx = x + (vector.length-1)*dx;
	  finy = y + (vector.length-1)*dy;

      if (  (finx>=0) && (finx<datos.length)
  	     && (finy>=0) && (finy<datos[0].length)) {

   	     px = x;
  	     py = y;

 	     for (k=0; k<vector.length; k++) {

		  	 if (datos[px][py]!=vector[k])
	  	        ok = false;
	      
 		     px += dx;
		     py += dy;
         }

      } else {
		 ok = false;
	  }

	  return ok;
  }  


  // 3. Por fuerza bruta

  private boolean encuentraPos3 (int vector[], int x, int y)
  {
	  int     k;
	  boolean encontrado;
	  
	  
	  encontrado = true;

	  for (k=0; k<vector.length; k++)
		  if ( (x+k>=datos.length) || (datos[x+k][y]!=vector[k]) )
		     encontrado = false;


      if (!encontrado) {
		  encontrado = true;

  	      for (k=0; k<vector.length; k++)
		      if ( (x-k<0) || (datos[x-k][y]!=vector[k]) )
		         encontrado = false;
	  }

      if (!encontrado) {
		  encontrado = true;

  	      for (k=0; k<vector.length; k++)
		      if ( (y+k>=datos[0].length) || (datos[x][y+k]!=vector[k]) )
		         encontrado = false;
	  }

      if (!encontrado) {
		  encontrado = true;

  	      for (k=0; k<vector.length; k++)
		      if ( (y-k<0) || (datos[x][y-k]!=vector[k]) )
		         encontrado = false;
	  }

      if (!encontrado) {
		  encontrado = true;

  	      for (k=0; k<vector.length; k++)
		      if ( (x+k>=datos.length) || (y+k>=datos[0].length) || (datos[x+k][y+k]!=vector[k]) )
		         encontrado = false;
	  }

      if (!encontrado) {
		  encontrado = true;

  	      for (k=0; k<vector.length; k++)
		      if ( (x+k>=datos.length) || (y-k<0) || (datos[x+k][y-k]!= vector[k]) )
		         encontrado = false;
	  }


      if (!encontrado) {
		  encontrado = true;

  	      for (k=0; k<vector.length; k++)
		      if ( (x-k<0) || (y+k>=datos[0].length) || (datos[x-k][y+k]!=vector[k]) )
		         encontrado = false;
	  }

      if (!encontrado) {
		  encontrado = true;

  	      for (k=0; k<vector.length; k++)
		      if ( (x-k<0) || (y-k<0) || (datos[x-k][y-k]!=vector[k]) )
		         encontrado = false;
	  }

	  return encontrado;
  }


  // Ejercicio 3: Recursividad
  // -------------------------

  private boolean g (int x)
  {
	  int i,j;

	  for (i=0; i<datos.length; i++)
		  for (j=0; j<datos[i].length; j++)
		      if (datos[i][j] == x)
		         return true;

	  return false;
  }


  public boolean f2 (int a, int b)
  {
    if (a>b)
	   return true;
    else if ( g(a) ) 
	   return f2(a+1,b);
    else 
 	   return false;
  }


  public boolean f3 (int a, int b)
  {
    if (a>b)
	   return true;
    else 
	   return g(a) && f3(a+1,b);
  }


  public boolean f (int a, int b)
  {
    if (a==b)
	   return g(a);
    else 
	   return g(a) && f(a+1,b);
  }

  public boolean fi (int a, int b)
  {
	  int x;
	  boolean resultado = true;

	  for (x=a; (x<=b) && resultado; x++)
		  resultado = g(x);

	  return resultado;
  }
		// NOTA:
		// resultado = g(x)
		// es equivalente a 
		// resultado = resultado && g(x)

  public boolean fi2 (int a, int b)
  {
	  boolean resultado = true;

	  while (a<=b) {
		  resultado = resultado && g(a);
		  a++;
	  }

	  return resultado;
  }





  // Test
  // ----

  public static void main (String args[])
  {
	 // Matriz limpia

     Matriz m0 = new Matriz(10,10);

	 System.out.println(m0);

	 System.out.println("f(0,0)="+m0.f(0,0));
	 System.out.println("f(0,1)="+m0.f(0,1));
	 System.out.println();

	 // Matriz 

	 Matriz ejemplo  = new Matriz ( new int[][]{{1,2,3,4},{4,3,2,1},{5,6,7,8},{8,7,6,5}} );
	 int    vector[] = new int[]{7,3,1};
	 int    pos[]    = ejemplo.encuentra ( vector );

	 System.out.println(ejemplo);

	 if (pos[0]!=-1)
		 System.out.println ("Vector encontrado en ("+pos[0]+","+pos[1]+")");
	 else
		 System.out.println ("Vector no encontrado");



  }

}